## mesa-6.5.1.tar.bz2

=== src/glut/fbdev/Makefile ===
# subset glut

TOP = ../../..
include $(TOP)/configs/current

GLX_SHARED = $(TOP)/src/glut/glx
MINI_SHARED = $(TOP)/src/glut/mini

GLUT_MAJOR = 3
GLUT_MINOR = 7
GLUT_TINY = 1

INCLUDES = -I$(TOP)/include -I$(GLX_SHARED)

CORE_SOURCES = \
	fbdev.c \
	colormap.c \
	cursor.c \
	menu.c \
	overlay.c \
	ext.c \
	state.c \
	input.c \
	callback.c \
	gamemode.c \
	vidresize.c \
	bitmap.c \
	stroke.c

GLX_SHARED_SOURCES = \
	$(GLX_SHARED)/glut_8x13.c \
	$(GLX_SHARED)/glut_9x15.c \
	$(GLX_SHARED)/glut_hel10.c \
	$(GLX_SHARED)/glut_hel12.c \
	$(GLX_SHARED)/glut_hel18.c \
	$(GLX_SHARED)/glut_tr10.c \
	$(GLX_SHARED)/glut_tr24.c \
	$(GLX_SHARED)/glut_mroman.c \
	$(GLX_SHARED)/glut_roman.c \

MINI_SHARED_SOURCES = \
	$(MINI_SHARED)/models.c \
	$(MINI_SHARED)/teapot.c

SOURCES = $(CORE_SOURCES)  $(GLX_SHARED_SOURCES) $(MINI_SHARED_SOURCES)

OBJECTS =  $(SOURCES:.c=.o)


##### RULES #####

.c.o:
	$(CC) -c $(INCLUDES) $(CFLAGS) $(DEFINES)  $< -o $@

.S.o:
	$(CC) -c $(INCLUDES) $(CFLAGS) $(DEFINES)  $< -o $@


##### TARGETS #####

default: depend $(TOP)/$(LIB_DIR)/$(GLUT_LIB_NAME)


# Make the library
$(TOP)/$(LIB_DIR)/$(GLUT_LIB_NAME): depend $(OBJECTS)
	$(TOP)/bin/mklib -o $(GLUT_LIB) -linker '$(CC)' \
		-major $(GLUT_MAJOR) -minor $(GLUT_MINOR) -patch $(GLUT_TINY) \
		$(GLUT_LIB_DEPS) -install $(TOP)/$(LIB_DIR) \
		$(MKLIB_OPTIONS) $(OBJECTS)

install:
	$(INSTALL) -d $(INSTALL_DIR)/include/GL
	$(INSTALL) -d $(INSTALL_DIR)/$(LIB_DIR)
	$(INSTALL) -m 644 $(TOP)/include/GL/glut.h $(INSTALL_DIR)/include/GL
	$(COPY_LIBS) $(TOP)/$(LIB_DIR)/libglut* $(INSTALL_DIR)/$(LIB_DIR)

# Run 'make -f Makefile.solo dep' to update the dependencies if you change
# what's included by any source file.
depend: $(SOURCES) 
	touch depend
	$(MKDEP) $(MKDEP_OPTIONS) $(INCLUDES) $(SOURCES) > /dev/null 

# Emacs tags
tags:
	etags `find . -name \*.[ch]` `find ../include`


# Remove .o and backup files
clean: depend
	-rm -f depend
	-rm -f *.o *~ *.o *~ *.so libglut.so.3.7

include depend

=== debian/changelog ===
mesa (6.5.1-0.6) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport a fix from mesa 6.5.2 to mesa 6.5.1 which:
     - fixes braces around the ASSERT macro;
     - fixes a clipping problem, which leads to systematic segfaults of the
       X server (Closes: #405803).

 -- Cyril Brulebois <cyril.brulebois@enst-bretagne.fr>  Thu, 22 Feb 2007 21:08:56 +0100

mesa (6.5.1-0.5) unstable; urgency=low

  * Non-maintainer upload.
  * Build with -fno-strict-aliasing to fix misbuild of i965_dri.so
    (closes: #394311).  Thanks to Michel Dänzer for the fix, and to Ryan
    Richter for the report and testing.

 -- Julien Cristau <julien.cristau@ens-lyon.org>  Wed,  3 Jan 2007 13:48:20 +0100

mesa (6.5.1-0.4) unstable; urgency=medium

  * Non-maintainer upload (and brown paper bag release).
  * _Depend_ on libx11-dev from libgl1-mesa-dev; revert previous change.
    Fixes FTBFS in other packages. (Really Closes: #396498)

 -- Steinar H. Gunderson <sesse@debian.org>  Sat, 11 Nov 2006 13:55:20 +0100

mesa (6.5.1-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Build-depend on libx11-dev; fixes FTBFS. (Closes: #396498)

 -- Steinar H. Gunderson <sesse@debian.org>  Wed,  8 Nov 2006 20:58:40 +0100

mesa (6.5.1-0.2) unstable; urgency=low

  * Non-maintainer upload
  * Disable generation of SSE instructions (closes: #390560)
  * Remove duplicate and unused build configurations
  * Remove extra source files left from CVS snapshots (closes: #389283)
  * Enable i965 DRI driver on i386 and amd64. Thanks to Ryan Richter
    for the patch. (closes: #392030)
  * Enable Unichrome DRI driver on amd64 (closes: #391900)
  * Enable FFB DRI driver on sparc, not i386 (closes: #388025)
  * Consistently compile C sources as C99 (closes: #373623)
  * Fix X display locking error in GLX. Thanks to Josh Triplett for
    the patch. (closes: #391681)

 -- Ben Hutchings <ben@decadent.org.uk>  Fri, 13 Oct 2006 02:25:52 +0100

mesa (6.5.1-0.1) unstable; urgency=low

  * New upstream version
  * Build-dep on x11proto-gl-dev >= 1.4.8
  * Stuff not in the upstream tarballs
    + os2 glut stuff
    + docs/gears.png
  * Bump libdrm-dev build-dep to >= 2.0.2
  * Add libdrm cflags to the debian-dri config. This allows the build system
    to find drm.h
  * Make sure that libGl looks for the dri drivers in the proper location. Do
    this by setting the appropriate variables in the debian config
  * Re-add s390 and m68k to the USE_IEEE test in src/mesa/main/imports.h. This
    package seriously needs to store patches somewhere that are easy to find
    and re-apply.
  * Add patch from Cyril Brulebois to allow package to build on HURD, which
    lacks DRI and directfb. This includes not using lib-directfb in the
    build-depends for hurd-i386. It also creates a new debian config,
    debian-indirect, which is used when building for HURD. This config is
    invoked in the debian-dri config on hurd-i386. Thanks to Cyril Brulebois
    for the patch, Michael Banck, Michel Dänzer, and Samuel Thibault for
    input on an appropriate fix. (closes: #358065)

 -- David Nusinow <dnusinow@debian.org>  Mon, 25 Sep 2006 21:21:47 -0400

mesa (6.5.0.cvs.20060524-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload mesa 6.5 cvs to unstable, because we need it for Xorg 7.1.
  * Upload with medium urgency instead of high, since this is a new
    upstream that should get some testing in unstable in spite of the
    multiple RC bugfixes.
  * Update debian/copyright with the full text of the SGI Free B and SGI
    MIT-style licenses in use in the package, and take a stab at
    cleaning up the list of paths and licenses.
    Closes: #368562.
  * Make mesa-common-dev Replaces: xlibosmesa-dev from sarge.
    Closes: #384057.
  * Fix libgl1-mesa-glx to not Provides: libgl1-mesa-dri, since it
    definitely doesn't provide DRI support and this Provides: breaks
    upgrades from sarge.  Closes: #384282.
  * debian/libgl1-mesa-swx11.shlibs: create a static shlibs file,
    because libOSMesa.so.6 is not provided by all implementations of
    libGL and so needs a separate shlibs declaration.  Also make
    libgl1-mesa-glx the default alternative instead of libgl1-mesa-swx11
    for consistency even when building against libgl1-mesa-swx11,
    because to the extent these are interchangeable (i.e., 99%...),
    there should be no reason to prefer one over the other -- and to the
    extent that they aren't interchangeable, it's wrong to list libgl1
    as an alternative dependency at all.  Closes: #386185.
  * Don't provide shlibs at all for libgl1-mesa-swx11-dbg; this is an
    unnecessary duplication of the existing libgl1-mesa-swx11 shlibs
    since packages should not really be linking against /usr/lib/debug/
    separately.
  * src/mesa/tnl/t_vb_render.c: Drop a pointless printf() in the
    RENDER_LINE macro, getting rid of copious debug output on console.
    Closes: #369895.
  * libgl1-mesa-swx11 has no reason to depend on libglu, anything that
    wants libglu will have its own dependency on it; drop this
    hard-coded dependency from debian/control.
  * Have libglu1-mesa-dev Provides: xlibmesa-glu-dev, since it's the
    successor to that package and xlibmesa-glu-dev is still referenced
    in a number of places and this makes for more reliable builds than
    depending on alternatives without requiring another dummy -dev
    package from xorg.
  * Replace references to Source-Version in debian/control with either 
    binary:Version or source:Version, depending on whether the
    relationship references an arch: any or arch: all package, making
    mesa binNMU-safe; add build-depends on dpkg-dev (>= 1.13.19) to
    ensure these substvars are available.

 -- Steve Langasek <vorlon@debian.org>  Fri, 15 Sep 2006 15:51:16 -0700

mesa (6.5.0.cvs.20060524-1) experimental; urgency=low

  * The "-O666 -fwater-c00ling -DBE_F4ST" release
  * New pull from CVS
  * Merge back and forth with 6.4.2-1


=== debian/control ===
Source: mesa
Section: graphics
Priority: optional
Maintainer: Mesa package maintainers <pkg-mesa-devel@lists.alioth.debian.org>
Uploaders: Marcelo E. Magallon <mmagallo@debian.org>
Standards-Version: 3.7.2
Build-Depends: lesstif2-dev, grep-dctrl, debhelper (>> 4), build-essential (>= 11), libdrm-dev (>= 2.0.2) [!hurd-i386], libdirectfb-dev [!hurd-i386], xutils, libexpat-dev, libxxf86vm-dev, libx11-dev, libxext-dev, pkg-config, x11proto-gl-dev (>= 1.4.8) , dpkg-dev (>= 1.13.19)

Package: libgl1-mesa-swx11
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: mesag3-glide, mesag3-glide2, mesag3+ggi, libgl1, nvidia-glx, mesag3, libgl1-mesa-swrast
Provides: libgl1, mesag3, libgl1-mesa-swrast
Replaces: libgl1, mesag3, libgl1-mesa-swrast
Description: A free implementation of the OpenGL API -- runtime
 Mesa is a 3-D graphics library with an API which is very similar to
 that of OpenGL.  To the extent that Mesa utilizes the OpenGL command
 syntax or state machine, it is being used with authorization from
 Silicon Graphics, Inc.  However, the author makes no claim that Mesa
 is in any way a compatible replacement for OpenGL or associated with
 Silicon Graphics, Inc.
 .
 This library provides a pure software rasteriser; it does not provide
 a direct rendering-capable library, or one which uses GLX.  For that,
 please see libgl1-mesa-glx.
 .
 On Linux, this library is also known as libGL or libGL.so.1.

Package: libgl1-mesa-swx11-dev
Section: libdevel
Architecture: any
Depends: libgl1-mesa-swx11 (= ${binary:Version}), libc6-dev, libx11-dev | xlibs-dev (>> 4.1.0), libxext6 | xlibs (>> 4.1.0), mesa-common-dev (= ${source:Version}), lesstif2-dev
Provides: libgl-dev, mesag3-widgets, mesag-widgets-dev, libglw-dev, mesag-dev, libgl1-mesa-swrast-dev
Conflicts: mesa-dev, libgl-dev, mesag3 (<< 3.1-1), nvidia-glx-dev, mesag-dev, libgl1-mesa-swrast-dev
Replaces: libgl-dev, mesag-dev, libgl1-mesa-swrast-dev
Description: A free implementation of the OpenGL API -- development support files
 This package provides the development environment required for
 compiling programs with Mesa.  For a complete description of Mesa,
 please look at the libgl1-mesa-swx11 package.
 .
 This package also provides a simple widgets library, libGLw, which
 allows Motif-based applications to embed an OpenGL drawing context.
 The headers and static libraries for compiling programs that use this
 library are included.
 .
 This library provides a pure software rasteriser; it does not provide
 a direct rendering-capable library, or one which uses GLX.  For that,
 please see libgl1-mesa-dev.

Package: libgl1-mesa-swx11-dbg
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: libgl1-mesa-swrast-dbg
Replaces: libgl1-mesa-swrast-dbg
Provides: libgl1-mesa-swrast-dbg
Description: A free implementation of the OpenGL API -- debugging package
 This package provides a debug-enabled version of the Mesa libraries.
 .
 For a complete description of Mesa, please look at the libgl1-mesa-swx11
 package.

Package: libgl1-mesa-glx
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: libgl1, libgl1-mesa-dri (<< 6.4.0)
Replaces: libgl1, libgl1-mesa-dri (<< 6.4.0)
Provides: libgl1
Description: A free implementation of the OpenGL API -- GLX runtime
 This version of Mesa provides GLX and DRI capabilities: it is capable of
 both direct and indirect rendering.  For direct rendering, it can use DRI
 modules from the libgl1-mesa-dri package to accelerate drawing.
 .
 This package does not include the modules themselves: these can be found
 in the libgl1-mesa-dri package.
 .
 For a complete description of Mesa, please look at the
 libgl1-mesa-swx11 package.

Package: libgl1-mesa-dri
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, libgl1-mesa-glx (= ${binary:Version})
Conflicts: xlibmesa-dri (<< 1:7.0.0)
Replaces: xlibmesa-dri (<< 1:7.0.0)
Description: A free implementation of the OpenGL API -- DRI modules
 This version of Mesa provides GLX and DRI capabilities: it is capable of
 both direct and indirect rendering.  For direct rendering, it can use DRI
 modules from the libgl1-mesa-dri package to accelerate drawing.
 .
 This package does not include the OpenGL library itself, only the DRI
 modules for accelerating direct rendering.
 .
 For a complete description of Mesa, please look at the
 libgl1-mesa-swx11 package.

Package: libgl1-mesa-dev
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, libx11-dev, libc6-dev, mesa-common-dev (= ${source:Version}), libgl1-mesa-glx (=${binary:Version}), libgl1-mesa-dri (= ${binary:Version})
Conflicts: libgl-dev, libgl1-mesa-dri-dev
Replaces: libgl-dev, libgl1-mesa-dri-dev
Provides: libgl-dev, libgl1-mesa-dri-dev
Description: A free implementation of the OpenGL API -- GLX development support files
 This version of Mesa provides GLX and DRI capabilities: it is capable of
 both direct and indirect rendering.  For direct rendering, it can use DRI
 modules from the libgl1-mesa-dri package to accelerate drawing.
 .
 This package includes headers and static libraries for compiling
 programs with Mesa.
 .
 For a complete description of Mesa, please look at the libgl1-mesa-swx11
 package.

Package: mesa-common-dev
Section: devel
Architecture: all
Replaces: xlibmesa-gl-dev (<< 1:7), xlibosmesa-dev
Description: Developer documentation for Mesa
 This package includes the specifications for the Mesa-specific OpenGL
 extensions, the complete set of release release notes and the
 development header files common to all Mesa packages.

Package: libosmesa6
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: Mesa Off-screen rendering extension
 OSmesa is a Mesa extension that allows programs to render to an
 off-screen buffer using the OpenGL API without having to create a
 rendering context on an X Server.  It uses a pure software renderer.
 .
 This package provides both 16-bit and 32-bit versions of the off-screen
 renderer which do not require external libraries to work.

Package: libosmesa6-dev
Section: devel
Architecture: any
Depends: libosmesa6 (= ${binary:Version}), libgl1-mesa-swx11-dev (= ${binary:Version})
Conflicts: xlibosmesa-dev, libosmesa4-dev, libosmesa-dev
Replaces: xlibosmesa-dev, libosmesa-dev
Provides: xlibosmesa-dev, libosmesa-dev
Description: Mesa Off-screen rendering extension -- development support files
 This package provides the required environment for developing programs
 that use the off-screen rendering extension of Mesa.
 .
 For more information on OSmesa see the libosmesa6 package.

Package: libglu1-mesa
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, libgl1-mesa-glx | libgl1
Provides: libglu1
Conflicts: mesag3 (<< 5.0.0-1), xlibmesa3, libglu1
Replaces: libglu1
Description: The OpenGL utility library (GLU)
 GLU offers simple interfaces for building mipmaps; checking for the
 presence of extensions in the OpenGL (or other libraries which follow
 the same conventions for advertising extensions); drawing
 piecewise-linear curves, NURBS, quadrics and other primitives
 (including, but not limited to, teapots); tesselating surfaces; setting
 up projection matrices and unprojecting screen coordinates to world
 coordinates.
 .
 On Linux, this library is also known as libGLU or libGLU.so.1.
 .
 This package provides the SGI implementation of GLU shipped with the
 Mesa package (ergo the "-mesa" suffix).

Package: libglu1-mesa-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, libglu1-mesa (= ${binary:Version}), libgl1-mesa-dev | libgl-dev
Provides: libglu-dev, xlibmesa-glu-dev
Conflicts: mesag-dev (<< 5.0.0-1), mesa-glide2-dev (<< 5.0.0-1), mesag3+ggi-dev (<< 5.0.0-1), xlibmesa-dev
Replaces: libglu-dev
Description: The OpenGL utility library -- development support files
 Includes headers and static libraries for compiling programs with GLU.
 .
 For a complete description of GLU, please look at the libglu1-mesa
 package.

Package: mesa-swx11-source
Section: libdevel
Architecture: all
Description: Mesa software rasteriser source -- development support files
 This package contains the source to the Mesa software rasteriser, which
 implements all of Mesa's GL support in software.  It powers the X11 and
 X server backends (assuming unaccelerated indirect).  This package is
 provided mainly for modular X servers which support GL, and need the
 software rasteriser source to build the GLcore module for unaccelerated
 indirect rendering.

=== debian/rules ===
#!/usr/bin/make -f

export DH_OPTIONS
export DEB_HOST_ARCH

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

STAMPDIR := debian/stamp

select_target_any = $(shell dh_listpackages -s | grep -v '^$$' | while read p ; do cut -d ' ' -f 1,3 debian/libdir.map | grep -w $$p ; done | grep -v _ | cut -d ' ' -f 1 | sort -u | grep ^$(1)- | cut -d - -f 2-)
select_target_arch = $(filter $(shell dh_listpackages -s | grep -v '^$$' | while read p ; do cut -d ' ' -f 1,3 debian/libdir.map | grep -w $$p ; done | grep _ | cut -d ' ' -f 1 | sort -u | grep ^$(1)- | cut -d - -f 2-), $(patsubst configs/%, %, $(wildcard configs/*_$(DEB_HOST_ARCH))))
select_target = $(sort $(BUILD_$(1)_TARGETS_any) $(BUILD_$(1)_TARGETS_arch))

BUILD_GL_TARGETS_any := $(call select_target_any,gl)
BUILD_GL_TARGETS_arch := $(call select_target_arch,gl)
BUILD_GL_TARGETS := $(call select_target,GL)

BUILD_GLU_TARGETS_any := $(call select_target_any,glu)
#BUILD_GLU_TARGETS_arch := $(call select_target_arch,glu)
BUILD_GLU_TARGETS := $(call select_target,GLU)

BUILD_GLW_TARGETS_any := $(call select_target_any,glw)
#BUILD_GLW_TARGETS_arch := $(call select_target_arch,glw)
BUILD_GLW_TARGETS := $(call select_target,GLW)

BUILD_TARGETS := \
	$(foreach t, $(BUILD_GL_TARGETS), $(STAMPDIR)/target-gl-$(t)) \
	$(foreach t, $(BUILD_GLU_TARGETS), $(STAMPDIR)/target-glu-$(t)) \
	$(foreach t, $(BUILD_GLW_TARGETS), $(STAMPDIR)/target-glw-$(t))

ifneq ($(strip $(shell grep-dctrl -n -s Package -PX libgl1-mesa-directfb debian/control)),)
DFB_MODULE_DIR := $(shell pkg-config --variable=moduledir directfb-internal)
endif

build: $(STAMPDIR)/build
$(STAMPDIR)/build: $(BUILD_TARGETS)
	dh_testdir
	mkdir -p $(dir $@) && touch $@

# Parameters:
#     1: library (gl, glu, glw)
#     2: target (debian, debian-i386, ...)
#     3: subdir to build (mesa, glw, glu/sgi)

driver_map = $(word $(2),$(shell grep '^$(1) ' debian/drivers.map))
libdir_map = $(word $(2),$(shell grep '^$(1) ' debian/libdir.map))

define build_target_actions
	dh_testdir
	chmod +x debian/shadowtree
	$(RM) -rf build/$(1)-$(2)
	debian/shadowtree build/$(1)-$(2)
	ln -sf $(2) build/$(1)-$(2)/configs/current
	if test $(1) != gl ; then \
		mkdir -p build/$(1)-$(2)/lib/ ; \
		ln -sf ../../gl-$(2)/lib/libGL.so build/$(1)-$(2)/lib/ ; \
	fi
	make -C build/$(1)-$(2)/src SRC_DIRS=$(3) DEBIAN_DRIVERS_DIR=$(if $(call driver_map,$(1)-$(2),1),/$(call driver_map,$(1)-$(2),3))
	if test $(1) != gl ; then \
		rm build/$(1)-$(2)/lib/libGL.so ; \
	fi
	mkdir -p $(dir $@) && touch $@
endef

$(STAMPDIR)/target-gl-%:
	$(call build_target_actions,gl,$*,mesa)

$(STAMPDIR)/target-glu-%: $(STAMPDIR)/target-gl-%
	$(call build_target_actions,glu,$*,glu/sgi)

$(STAMPDIR)/target-glw-%: $(STAMPDIR)/target-gl-%
	$(call build_target_actions,glw,$*,glw)

# Parameters:
#     1: target (gl-debian, gl-debian-i386, ...)
#     2: installation directory (usr/lib, usr/lib/dbg, ...)
#     3: library package name
#     4: development package name

define install_target_lib_actions
	dh_installdirs -p$(3) $(2)
	dh_installdirs -p$(4) $(2)
	dh_install -p$(3) build/$(1)/lib/lib*.so.* $(2)
	dh_install -p$(4) build/$(1)/lib/lib*.so $(2)
	dh_install -p$(4) build/$(1)/lib/lib*.a $(2)
endef

install_target_libs = $(call install_target_lib_actions,$(1),$(call libdir_map,$(1),2),$(call libdir_map,$(1),3),$(call libdir_map,$(1),4))

# Parameters:
#     1: target (gl-debian, gl-debian-i386, ...)
#     2: source directory (usr/lib, usr/lib/dbg, ...)
#     3: installation directory (usr/lib, usr/lib/dbg, ...)
#     4: package name

define install_target_driver_actions
	dh_installdirs -p$(4) $(3)
	dh_install -p$(4) build/$(1)/$(2) $(3)
endef

install_target_drivers = $(if $(call driver_map,$(1),1),$(call install_target_driver_actions,$(1),$(call driver_map,$(1),2),$(call driver_map,$(1),3),$(call driver_map,$(1),4)))

# Parameters:
#     1: target (gl-debian, gl-debian-i386, ...)

define install_target
	$(call install_target_libs,$(1))
	$(call install_target_drivers,$(1))
endef

install-target-%: $(STAMPDIR)/target-%
	@echo Target $@.
	$(call install_target,$*)
	@echo Target $@: done.

install-pre:
	@echo Target $@.
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	@echo Target $@: done.

install-all: install-pre \
	$(addprefix install-target-gl-,$(BUILD_GL_TARGETS)) \
	$(addprefix install-target-glu-,$(BUILD_GLU_TARGETS)) \
	$(addprefix install-target-glw-,$(BUILD_GLW_TARGETS))
	@echo Target $@.
	@echo Target $@: done.

clean:
	dh_testdir
	dh_testroot
	$(RM) -rf debian/stamp
	$(RM) -rf build
	dh_clean debian/mesa-swx11-source.install

install: build install-all
	@echo Target $@.
	@echo Target $@: done.

binary-indep: DH_OPTIONS := -i
binary-indep: debian/mesa-swx11-source.install build
	@echo Target $@
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installdirs
#	dh_installexamples
	dh_install
#	dh_installman
#	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb
	@echo Target $@: done.

# binary-arch: DH_OPTIONS := -s
binary-arch: build install
	@echo Target $@
	dh_testdir -s
	dh_testroot -s
	dh_installchangelogs -s
	dh_installdocs -s
#	dh_installexamples -s
	dh_install -s
#	dh_installman -s
#	dh_link -s
	dh_strip -s
	dh_compress -s
	dh_fixperms -s
#	dh_makeshlibs -s -Nlibglu1-mesa -Nmesag3
ifneq ($(strip $(shell dh_listpackages -s | grep -w libgl1-mesa-glide3)),)
	dh_makeshlibs -plibgl1-mesa-glide3 -V 'libgl1-mesa-glide3'
endif
ifneq ($(strip $(shell dh_listpackages -s | grep -w libglu1-mesa)),)
	dh_makeshlibs -plibglu1-mesa -V 'libglu1-mesa | libglu1'
endif
ifneq ($(strip $(shell dh_listpackages -s | grep -w libosmesa6)),)
	dh_makeshlibs -plibosmesa6
endif
ifneq ($(strip $(shell dh_listpackages -s | grep -w libgl1-mesa-swx11)),)
	dh_makeshlibs -plibgl1-mesa-swx11
endif
ifneq ($(strip $(shell dh_listpackages -s | grep -w libgl1-mesa-glx)),)
	dh_makeshlibs -plibgl1-mesa-glx -V 'libgl1-mesa-glx | libgl1'
endif
ifneq ($(strip $(shell dh_listpackages -s | grep -w libgl1-mesa-directfb)),)
	dh_makeshlibs -plibgl1-mesa-directfb -V 'libgl1-mesa-directfb | libgl1'
endif
# Make sure nothing has been left behind.
	find debian -mindepth 2 -name shlibs | cut -d / -f 2 | sort -u > \
		debian/shlibs.actual
	find debian -mindepth 2 -name lib\*.so.\* | grep -v dbg | cut -d / -f 2 | sort -u > \
		debian/shlibs.should
	cmp debian/shlibs.actual debian/shlibs.should
	rm debian/shlibs.actual debian/shlibs.should
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s
	dh_md5sums -s
	dh_builddeb -s
	@echo Target $@: done.

list-targets:
	@for t in $(BUILD_GL_TARGETS_arch) ; do echo $$t ; done

debian/mesa-swx11-source.install:
	( find src/mesa src/glx/x11 include/GL/internal -name '*.[ch]' ; \
	  find include/GL -name 'xmesa*' ) | \
	egrep -v 'drivers/(dri/(fb|ffb|gamma|i[a-z0-9]+|mach64|mga|r[0-9]+|radeon|s3v|savage|sis|tdfx|trident|unichrome)|directfb|dos|fbdev|ggi|glide|osmesa|svga|windows)/' | \
	while read x; do echo $$x usr/share/mesa-source/`dirname $$x`; done \
	> $@

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure debian/mesa-swx11-source.install
